package com.dsvision.geolocalisation
{
	import com.google.maps.InfoWindowOptions;
	import com.google.maps.LatLng;
	import com.google.maps.Map;
	import com.google.maps.Map3D;
	import com.google.maps.MapEvent;
	import com.google.maps.MapOptions;
	import com.google.maps.MapType;
	import com.google.maps.View;
	import com.google.maps.controls.MapTypeControl;
	import com.google.maps.controls.PositionControl;
	import com.google.maps.controls.ZoomControl;
	import com.google.maps.geom.Attitude;
	import com.google.maps.geom.Point3D;
	import com.google.maps.overlays.Marker;
	import com.google.maps.overlays.MarkerOptions;
	
	import flash.display.Sprite;
	import flash.events.*;
	import flash.external.ExternalInterface;
	import flash.geom.Point;
	
	
	public class gps extends Sprite
	{
		private var map:Map3D;
		private var container:Sprite= new Sprite();
		
		private var getGeo:String;
		private var sendGeo:String;
		private var mapWidth:int;
		private var mapHeight:int;
		private var key:String;
		
		public function gps(width:int, height:int,APIkey:String, getGeoFunction:String, sendGeoFunction:String){
			
			mapWidth = width;
			mapHeight = height;
			key = APIkey;
			getGeo = getGeoFunction;
			sendGeo = sendGeoFunction;
			container.addEventListener(Event.ADDED_TO_STAGE, init);
			
			this.addChild(container);
		}
		private function init(e:Event):void{
			map = new Map3D();
			map.key = key;
			map.sensor = "false";
			map.addControl(new ZoomControl());
			map.addControl(new PositionControl());
			map.addControl(new MapTypeControl());

			map.setSize(new Point(mapWidth, mapHeight));
			map.addEventListener(MapEvent.MAP_READY, onMapReady);
			map.addEventListener(MapEvent.MAP_PREINITIALIZE, onMapInit);
			map.addEventListener(MapEvent.FLY_TO_DONE, displayInfo);
			addChild(Sprite(map));
			
			if (ExternalInterface.available) {
				//check if external interface is available
				try {
					ExternalInterface.call(getGeo);
					// add Callback for the passGEOToSWF Javascript function
					ExternalInterface.addCallback(sendGeo, onPassGEOToSWF);
				} catch (error:SecurityError) {
					// Alert the user of a SecurityError
				} catch (error:Error) {
					// Alert the user of an Error
				}
			}
		}
		private function onMapInit(event:Event):void
		{
			var myMapOptions:MapOptions = new MapOptions();
			myMapOptions.zoom = 1.15;
			myMapOptions.center = new LatLng(30.756054, -23.986951);
			myMapOptions.mapType = MapType.HYBRID_MAP_TYPE;
			myMapOptions.viewMode = View.VIEWMODE_PERSPECTIVE;
			myMapOptions.attitude = new Attitude(0,0,0);
			map.setInitOptions(myMapOptions);
		}
		private function onMapReady(event:Event):void
		{
			//map.disableDragging();
			// call the Javascript function getGEO
			ExternalInterface.call("getGEO");
		}
		
		private function flyTo(lat:Number, long:Number):void
		{
			map.flyTo(new LatLng(lat,long),15.4,new Attitude(0,45,30),12);
			var marker:Marker = new Marker(new LatLng(lat,long));
			map.addOverlay(marker);
		}
		
		private function onPassGEOToSWF(lat:Number,long:Number):void
		{
			flyTo(lat,long);
		}
		private function displayInfo(e:MapEvent):void{
			map.openInfoWindow(map.getCenter(), new InfoWindowOptions({content: "You are here"}));
		}
		
		
	}
	
}